'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _console = require('console');

var _console2 = _interopRequireDefault(_console);

var _spawnCommand = require('spawn-command');

var _spawnCommand2 = _interopRequireDefault(_spawnCommand);

var _safe = require('colors/safe');

var _safe2 = _interopRequireDefault(_safe);

var _lodash = require('lodash.isstring');

var _lodash2 = _interopRequireDefault(_lodash);

var _getScriptToRun = require('./get-script-to-run');

var _getScriptToRun2 = _interopRequireDefault(_getScriptToRun);

var _getScriptsFromConfig = require('./get-scripts-from-config');

var _getScriptsFromConfig2 = _interopRequireDefault(_getScriptsFromConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-console:0 */
exports.default = runPackageScript; // to allow easy rewiring

function runPackageScript(psConfig, scriptName, argsToPassOn) {
  var _psConfig$options = psConfig.options;
  var options = _psConfig$options === undefined ? {} : _psConfig$options;

  var scripts = (0, _getScriptsFromConfig2.default)(psConfig, scriptName);
  var script = (0, _getScriptToRun2.default)(scripts, scriptName);
  if (!(0, _lodash2.default)(script)) {
    throw new Error('scripts must resolve to strings');
  }
  var command = [script, argsToPassOn].join(' ').trim();
  if (!options.silent) {
    _console2.default.log(_safe2.default.gray('p-s executing: ') + _safe2.default.green(command));
  }
  (0, _spawnCommand2.default)(command, { stdio: 'inherit', env: process.env }).on('exit', process.exit);
}